<?php

/**
 * registro_nd actions.
 *
 * @package    cobro_coactivo
 * @subpackage registro_nd
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class registro_ndActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_REGISTRO_ND', 'CBR_REGISTRO_CONCEPTO',
        'CBR_TITULO_MINERO_V',
        'CBR_RESOLUCION_TIT',
        'CBR_CONCEPTO_DEUDA', 'CA_DEBITO_COBRO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REGISTRO_CONCEPTO' =>
        array(
            'id_registro_concepto' => 'CBR_REGISTRO_ND'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REGISTRO_CONCEPTO'
        ),
        'CA_DEBITO_COBRO_V' =>
        array(
            'id_debito' => 'CBR_REGISTRO_ND'
        ),
        'CBR_RESOLUCION_TIT' =>
        array(
            'id_resolucion_tit' => 'CBR_REGISTRO_CONCEPTO'
        ),
        'CBR_CONCEPTO_DEUDA' =>
        array(
            'id_concepto_deuda' => 'CBR_REGISTRO_CONCEPTO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_REGISTRO_ND' =>
        array(
            'id_registro_nd' => 'id_registro_nd',
            'id_registro_concepto' => 'id_registro_concepto',
            'id_debito' => 'id_debito'
        ),
        'CBR_REGISTRO_CONCEPTO' =>
        array(
            'cod_titulo' => 'cod_titulo',
            'id_resolucion_tit' => 'id_resolucion_tit',
            'id_concepto_deuda' => 'id_concepto_deuda',
            'valor' => 'valor',
            'abonos' => 'abonos',
            'saldo' => 'saldo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debitos',
            'id_mineral' => 'id_mineral'
        ),
        'CBR_RESOLUCION_TIT' =>
        array(
            'no_resolucion' => 'no_resolucion',
            'fecha_expedicion' => 'fecha_resolucion'
        ),
        'CBR_CONCEPTO_DEUDA' =>
        array(
            'descripcion' => 'descripcion_concepto'
        ),
        'CA_DEBITO_COBRO_V' =>
        array(
            'sec_debito' => 'sec_debito',
            'fecha_proceso' => 'fecha_proceso',
            'saldo_actual' => 'saldo_actual',
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_REGISTRO_ND' =>
        array(
            'id_registro_nd,a' => array('!=' => array(-1)),
            'id_registro_nd,b' => array('=' => array('id_registro_nd')),
            'id_registro_concepto' => array('=' => array('id_registro_concepto')),
            'id_debito' => array('=' => array('id_debito')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_registro_nd'; //identificador de la tabla
    protected $id_names = array('id_registro_nd'); //llave primaria
    protected $field_names = array('id_registro_concepto', 'id_debito'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_REGISTRO_ND'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_registro_nd'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //$request['abonos']=0;
            $request['saldo'] = $request['valor'];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
